rm(list=ls())

load("/home/philippe/Dropbox/OrdiPC/R/Post-doc/BorealBirds_ALPAC/Depot_DD/birddensity.df.Rdata")

require(ggplot2)
library(doBy)
library(gsubfn)
library(plyr)
require(ggplot2)



################################ Table 3 and S2.1 
ba <- birddensity.df
ba=subset(ba, !is.na(meanBirdDensity))
ba=subset(ba, Year=="2100") # On compare au baseline à l'année 2100
# table(ba$spind)

for (i in unique(ba$spind)){
  baseX=ba$meanBirdDensity[ba$spind=="baselineDrought_3_mortHarvestBaselineFire"]
  val=ba$meanBirdDensity[ba$spind==i]
  ba$PropBaseline[ba$spind==i]=ifelse(val>=baseX, ((val-baseX)/baseX), -((baseX-val)/baseX))}
#

ba2 <- summaryBy(PropBaseline ~ Species +scenario + HarvestTreatment + Year + FireTreatment+Nesting+ForagingHabitat+Composition+Age+Site+AgeCover, data = ba)
head(ba2)
ba2$PropBaseline=ba2$PropBaseline.mean
#### Barres d'erreurs
ba3=summaryBy(PropBaseline ~ Species +scenario + HarvestTreatment + Year + FireTreatment+Nesting+ForagingHabitat+Composition+Age+Site+AgeCover,FUN=sd, data = ba)
head(ba3)

ba3$sd=ba3$PropBaseline.sd
ba3$se=ba3$sd/sqrt(5)#se   = sd / sqrt(N)
# ba3$IC=qnorm(0.975)*(ba3$sd/sqrt(5))#qnorm(0.975)*s/sqrt(n)
ba3$IC=qt(0.975,df=4)*ba3$sd/sqrt(5)
ba2$SE=ba3$se
ba2$IC=ba3$IC
ba2$SD=ba3$sd

ba=ba2

vo=ba[0,]
for (i in unique(ba$HarvestTreatment)){ 
  for (t in unique(ba$scenario)){ 
    # i="Drought_3_mortHarvest"
    # t="RCP85"
    ba2=ba[!is.na(ba$AgeCover),]
    ba2=subset(ba2, HarvestTreatment==i&scenario==t)
    co=rbind(ba2[ba2$AgeCover=="treeless",],
             ba2[ba2$AgeCover=="deciduous_early",],
             ba2[ba2$AgeCover=="mixedwood_early",],
             ba2[ba2$AgeCover=="coniferous_early",],
             ba2[ba2$AgeCover=="deciduous_mid",],
             ba2[ba2$AgeCover=="mixedwood_mid",],
             ba2[ba2$AgeCover=="coniferous_mid",],
             ba2[ba2$AgeCover=="deciduous_mature",],
             ba2[ba2$AgeCover=="mixedwood_mature",],
             ba2[ba2$AgeCover=="coniferous_mature",],
             ba2[ba2$AgeCover=="deciduous_late",],
             ba2[ba2$AgeCover=="mixedwood_late",],
             ba2[ba2$AgeCover=="coniferous_late",])
    # co$AgeCover=relevel(co$AgeCover, "grassland")
    co$AgeCover=as.factor(co$AgeCover)
    co$AgeCover=relevel(co$AgeCover, "treeless")
    co$AgeCover=relevel(co$AgeCover, "deciduous_early")
    co$AgeCover=relevel(co$AgeCover, "mixedwood_early")
    co$AgeCover=relevel(co$AgeCover, "coniferous_early")
    co$AgeCover=relevel(co$AgeCover, "deciduous_mid")
    # co$AgeCover=relevel(co$AgeCover, "mixedwood_mid")
    co$AgeCover=relevel(co$AgeCover, "coniferous_mid")
    co$AgeCover=relevel(co$AgeCover, "deciduous_mature")
    co$AgeCover=relevel(co$AgeCover, "mixedwood_mature")
    co$AgeCover=relevel(co$AgeCover, "coniferous_mature")
    co$AgeCover=relevel(co$AgeCover, "deciduous_late")
    co$AgeCover=relevel(co$AgeCover, "mixedwood_late")
    co$AgeCover=relevel(co$AgeCover, "coniferous_late")
    co$Species2=co$Species
    co$Species=factor(c(co$Species), levels=c(as.character(co$Species)))
    vo=rbind(co,vo)}}


tb=data.frame(Species=as.factor(unique(vo$Species)),Year="2100",Scenario="RCP85")
for( i in tb$Species){
  tb$AgeCover[tb$Species==i]=as.character(vo$AgeCover[vo$Species==i][1])
  tb$NoHarvest[tb$Species==i]=round(vo$PropBaseline[vo$Species==i&vo$HarvestTreatment=="Drought_0_mortHarvest"&vo$scenario=="RCP85"]*100)
  tb$NoHarvestSD[tb$Species==i]=round(vo$SD[vo$Species==i&vo$HarvestTreatment=="Drought_0_mortHarvest"&vo$scenario=="RCP85"]*100,1)
  tb$Harvest0.3[tb$Species==i]=round(vo$PropBaseline[vo$Species==i&vo$HarvestTreatment=="Drought_3_mortHarvest"&vo$scenario=="RCP85"]*100)
  tb$Harvest0.3SD[tb$Species==i]=round(vo$SD[vo$Species==i&vo$HarvestTreatment=="Drought_3_mortHarvest"&vo$scenario=="RCP85"]*100,1)
  tb$Harvest0.6[tb$Species==i]=round(vo$PropBaseline[vo$Species==i&vo$HarvestTreatment=="Drought_6_mortHarvest"&vo$scenario=="RCP85"]*100)
  tb$Harvest0.6SD[tb$Species==i]=round(vo$SD[vo$Species==i&vo$HarvestTreatment=="Drought_6_mortHarvest"&vo$scenario=="RCP85"]*100,1)}

### RCP8.5 2100
load("Depot_DD/rq100.Rdata", verbose=T)

for( i in tb$Species){
  # i="Cedar Waxwing"
  tb$Fire[tb$Species==i]=round(rq100$Fire[rq100$Species==i&rq100$Scenario=="RCP85"]*100)
  tb$Growth[tb$Species==i]=round(rq100$Growth[rq100$Species==i&rq100$Scenario=="RCP85"]*100)
  tb$Harvest[tb$Species==i]=round(rq100$Harvest[rq100$Species==i&rq100$Scenario=="RCP85"]*100)}
tb$Keep25[tb$Harvest0.3>25]="keep"
tb$Keep25[tb$Harvest0.3< -25]="keep"
tb$Keep25[is.na(tb$Keep25)]="No"
table(tb$Keep25)

### Correction 29 janv 2020 des noms de types d'habitats
tb$AgeCover[tb$AgeCover%in%c("deciduous_early")]="deciduous <30yr"
tb$AgeCover[tb$AgeCover%in%c("deciduous_mid")]="deciduous 30-60yr"
tb$AgeCover[tb$AgeCover%in%c("deciduous_mature")]="deciduous 60-80yr"
tb$AgeCover[tb$AgeCover%in%c("deciduous_late")]="deciduous >80yr"

tb$AgeCover[tb$AgeCover%in%c("mixedwood_early")]="mixedwood <30yr"
tb$AgeCover[tb$AgeCover%in%c("mixedwood_mid")]="mixedwood 30-60yr"
tb$AgeCover[tb$AgeCover%in%c("mixedwood_mature")]="mixedwood 60-80yr"
tb$AgeCover[tb$AgeCover%in%c("mixedwood_late")]="mixedwood >80yr"

tb$AgeCover[tb$AgeCover%in%c("coniferous_early")]="coniferous <30yr"
tb$AgeCover[tb$AgeCover%in%c("coniferous_mid")]="coniferous 30-60yr"
tb$AgeCover[tb$AgeCover%in%c("coniferous_mature")]="coniferous 60-80yr"
tb$AgeCover[tb$AgeCover%in%c("coniferous_late")]="coniferous >80yr"
# tb$Keep25=NULL

### corr nom Canada Jay
tb$Species=as.character(tb$Species)
tb$Species[tb$Species=="Gray Jay"]="Canada Jay"
tb$Species=as.factor(tb$Species)

### corr nom Canada Jay
tb$Species=as.character(tb$Species)
tb$Species[tb$Species=="Gray Jay"]="Canada Jay"
tb$Species=as.factor(tb$Species)
######## Ajout de SD pour le tableau S2.1 
tb2=tb
tb2$NoHarvest=paste(tb2$NoHarvest," ±",tb2$NoHarvestSD,sep="") 
tb2$Harvest0.3=paste(tb2$Harvest0.3," ±", tb2$Harvest0.3SD,sep="")
tb2$Harvest0.6=paste(tb2$Harvest0.6," ±", tb2$Harvest0.6SD,sep="")
tb2$NoHarvestSD=NULL
tb2$Harvest0.3SD=NULL
tb2$Harvest0.6SD=NULL
# write.csv(tb2,"Depot_DD/Table3_S2.1.csv")














########################################## Fig. 6

ba <- birddensity.df
ba=subset(ba, !is.na(meanBirdDensity))

for(y in unique(ba$Year)){
  for (i in unique(ba$spind)){
    baseX=ba$meanBirdDensity[ba$spind=="baselineDrought_3_mortHarvestBaselineFire"&ba$Year==y]
    val=ba$meanBirdDensity[ba$spind==i&ba$Year==y]
    ba$PropBaseline[ba$spind==i&ba$Year==y]=ifelse(val>=baseX, ((val-baseX)/baseX), -((baseX-val)/baseX))
  }
  print(round(100*(which(unique(ba$Year)==y)/length(unique(ba$Year)))))}

by=summaryBy(PropBaseline ~ scenario+treatment + Species + Year + meanBirdDensity+Nesting+ForagingHabitat+Composition+Age+Site+AgeCover+FireTreatment,FUN=mean, data = ba)
by$PropBaseline=by$PropBaseline.mean
by=by[by$scenario=="RCP85"&by$HarvestTreatment=="Drought_3_mortHarvest"&by$Year=="2100",]

ba$AgeCover=as.factor(ba$AgeCover)
ba$AgeCover=relevel(ba$AgeCover, "treeless")
ba$AgeCover=relevel(ba$AgeCover, "deciduous_early")
ba$AgeCover=relevel(ba$AgeCover, "mixedwood_early")
ba$AgeCover=relevel(ba$AgeCover, "coniferous_early")
ba$AgeCover=relevel(ba$AgeCover, "deciduous_mid")
ba$AgeCover=relevel(ba$AgeCover, "coniferous_mid")
ba$AgeCover=relevel(ba$AgeCover, "deciduous_mature")
ba$AgeCover=relevel(ba$AgeCover, "mixedwood_mature")
ba$AgeCover=relevel(ba$AgeCover, "coniferous_mature")
ba$AgeCover=relevel(ba$AgeCover, "deciduous_late")
ba$AgeCover=relevel(ba$AgeCover, "mixedwood_late")
ba$AgeCover=relevel(ba$AgeCover, "coniferous_late")

bu=subset(ba, AgeCover%in%c("coniferous_late", "mixedwood_late", "deciduous_late", "coniferous_mid","mixedwood_mid", "deciduous_mid")&scenario=="RCP85"&HarvestTreatment=="Drought_6_mortHarvest")

by=summaryBy(PropBaseline ~ AgeCover + HarvestTreatment +Year+scenario, data = ba)
bySD=summaryBy(PropBaseline ~ AgeCover + HarvestTreatment +Year+scenario, data = ba, FUN=sd)
by$MeanProp=by$PropBaseline.mean*100
by$SD=bySD$PropBaseline.sd*100

by=by[by$Year%in%c(2000, 2010, 2020, 2030, 2040, 2050, 2060, 2070, 2080, 2090, 2100),]
bymax=summaryBy(PropBaseline ~ AgeCover + HarvestTreatment +Year+scenario, data = ba, FUN=max)
by$Max=bymax$PropBaseline.max*100
bymin=summaryBy(PropBaseline ~ AgeCover + HarvestTreatment +Year+scenario, data = ba, FUN=min)
by$Min=bymin$PropBaseline.min*100

by$HarvestTreatment[by$HarvestTreatment=="Drought_0_mortHarvest"]="No harvest"
by$HarvestTreatment[by$HarvestTreatment=="Drought_3_mortHarvest"]="Current harvest"
by$HarvestTreatment[by$HarvestTreatment=="Drought_6_mortHarvest"]="High harvest"
by$HarvestTreatment=as.factor(by$HarvestTreatment)
by$HarvestTreatment=relevel(by$HarvestTreatment, "High harvest")
by$HarvestTreatment=relevel(by$HarvestTreatment, "Current harvest")
by$HarvestTreatment=relevel(by$HarvestTreatment, "No harvest")

######################## Figure 6b 
table(ba$AgeCover)/252
nrow(ba[ba$Species=="White-crowned Sparrow",])

byhab=by[by$AgeCover%in%c("coniferous_early",  "mixedwood_early","coniferous_late", "mixedwood_late",  "coniferous_mid","mixedwood_mid",  "coniferous_mature","mixedwood_mature"),]

byhab$HarvestTreatment=as.character(byhab$HarvestTreatment)
byhab$HarvestTreatment[byhab$HarvestTreatment=="No harvest"]="No Harvesting"
byhab$HarvestTreatment[byhab$HarvestTreatment=="High harvest"]="High Harvesting"
byhab$HarvestTreatment[byhab$HarvestTreatment=="Current harvest"]="Baseline Harvesting"
byhab$HarvestTreatment=as.factor(byhab$HarvestTreatment)
byhab$HarvestTreatment=relevel(byhab$HarvestTreatment,"High Harvesting")
byhab$HarvestTreatment=relevel(byhab$HarvestTreatment,"Baseline Harvesting")
byhab$HarvestTreatment=relevel(byhab$HarvestTreatment,"No Harvesting")

byhab$AgeCover=as.character(byhab$AgeCover)
byhab$AgeCover[byhab$AgeCover=="coniferous_early"]="Young coniferous"
byhab$AgeCover[byhab$AgeCover=="mixedwood_early"]="Young mixedwood"
byhab$AgeCover[byhab$AgeCover=="coniferous_late"]="Old coniferous"
byhab$AgeCover[byhab$AgeCover=="mixedwood_late"]="Old mixedwood"
byhab$AgeCover[byhab$AgeCover=="coniferous_mid"]="Closed coniferous"
byhab$AgeCover[byhab$AgeCover=="mixedwood_mid"]="Closed mixedwood"
byhab$AgeCover[byhab$AgeCover=="coniferous_mature"]="Mature coniferous"
byhab$AgeCover[byhab$AgeCover=="mixedwood_mature"]="Mature mixedwood"
byhab$AgeCover=as.factor(byhab$AgeCover)
table(byhab$AgeCover)

byhab$AgeCover=relevel(byhab$AgeCover,"Old coniferous")
byhab$AgeCover=relevel(byhab$AgeCover,"Old mixedwood")
byhab$AgeCover=relevel(byhab$AgeCover,"Mature coniferous")
byhab$AgeCover=relevel(byhab$AgeCover,"Mature mixedwood")
byhab$AgeCover=relevel(byhab$AgeCover,"Closed coniferous")
byhab$AgeCover=relevel(byhab$AgeCover,"Young coniferous")
byhab$AgeCover=relevel(byhab$AgeCover,"Young mixedwood")

ggplot(byhab[byhab$scenario=="RCP85",], aes(x=Year, y=MeanProp, group=AgeCover))+facet_wrap(~HarvestTreatment)+geom_line(aes(linetype=AgeCover, colour=AgeCover))+scale_y_continuous(breaks =c(-100,-75,-50,-25,0,25,50,75,100,150),limits = c(-50,25))+ylab("Percentage change (%)")+theme(axis.text.x = element_text(angle = 45, hjust = 1))+ guides(fill = guide_legend(keywidth = 1, keyheight = 1),linetype=guide_legend(keywidth = 3, keyheight = 1), colour=guide_legend(keywidth = 3, keyheight = 1)) +theme(legend.title=element_blank())

# ggsave("Depot_DD/Fig_6a_3x8.tiff", plot = last_plot(),width = 8, height = 3, units = c("in"),dpi = 350)



######################## Figure 6a 

byhab=by[by$AgeCover%in%c( "treeless","deciduous_early", "deciduous_mid","deciduous_mature","deciduous_late"),]

byhab$HarvestTreatment=as.character(byhab$HarvestTreatment)
byhab$HarvestTreatment[byhab$HarvestTreatment=="No harvest"]="No Harvesting"
byhab$HarvestTreatment[byhab$HarvestTreatment=="High harvest"]="High Harvesting"
byhab$HarvestTreatment[byhab$HarvestTreatment=="Current harvest"]="Baseline Harvesting"
byhab$HarvestTreatment=as.factor(byhab$HarvestTreatment)
byhab$HarvestTreatment=relevel(byhab$HarvestTreatment,"High Harvesting")
byhab$HarvestTreatment=relevel(byhab$HarvestTreatment,"Baseline Harvesting")
byhab$HarvestTreatment=relevel(byhab$HarvestTreatment,"No Harvesting")

byhab$AgeCover=as.character(byhab$AgeCover)
byhab$AgeCover[byhab$AgeCover=="deciduous_early"]="Young deciduous"
byhab$AgeCover[byhab$AgeCover=="deciduous_mid"]="Closed deciduous"
byhab$AgeCover[byhab$AgeCover=="deciduous_mature"]="Mature deciduous"
byhab$AgeCover[byhab$AgeCover=="deciduous_late"]="Old deciduous"
byhab$AgeCover[byhab$AgeCover=="treeless"]="Treeless"
byhab$AgeCover=as.factor(byhab$AgeCover)

byhab$AgeCover=relevel(byhab$AgeCover,"Old deciduous")
byhab$AgeCover=relevel(byhab$AgeCover,"Mature deciduous")
byhab$AgeCover=relevel(byhab$AgeCover,"Closed deciduous")
byhab$AgeCover=relevel(byhab$AgeCover,"Young deciduous")
byhab$AgeCover=relevel(byhab$AgeCover,"Treeless")

ggplot(byhab[byhab$scenario=="RCP85",], aes(x=Year, y=MeanProp, group=AgeCover))+facet_wrap(~HarvestTreatment)+geom_line(aes(linetype=AgeCover, colour=AgeCover))+scale_y_continuous(breaks =c(-100,-75,-50,-25,0,25,50,75,100),limits = c(-25,100))+ylab("Percentage change (%)")+theme(axis.text.x = element_text(angle = 45, hjust = 1))+ guides(fill = guide_legend(keywidth = 1, keyheight = 1),linetype=guide_legend(keywidth = 3, keyheight = 1), colour=guide_legend(keywidth = 3, keyheight = 1))+theme(legend.title=element_blank())

# ggsave("Depot_DD/Fig_6a_3x8.tiff", plot = last_plot(),width = 8, height = 3, units = c("in"),dpi = 350)

