####################################################
rm(list=ls())
require(ggplot2)
require(doBy)

setwd("/home/philippe/Dropbox/OrdiPC/R/Post-doc/BorealBirds_ALPAC/")
# save.image(file="Depot_DD/Veg_Fig4_Fig5_Depot.Rdata")
load("Depot_DD/Veg_Fig4_Fig5_Depot.Rdata")


#################################################### Fiigure 4

### defining breaks
StartYear=2000
if(max(Habitat.freq.df.aveHabitatSimpleForGraph$Year)==2100) {
  breaks <- c(2010, 2040, 2070, 2100)
} else {
  breaks <- seq(from=StartYear, to=max(Habitat.freq.df.aveHabitatSimpleForGraph$Year), by=100)
}


### defining breaks
StartYear=2000
if(max(Habitat.freq.df.aveCoverForGraph$Year)==2100) {
  breaks <- c(2010, 2040, 2070, 2100)
} else {
  breaks <- seq(from=StartYear, to=max(Habitat.freq.df.aveCoverForGraph$Year), by=100)
}

Habitat.freq.df.aveCoverForGraph$CoverClassNiceNames=as.character(Habitat.freq.df.aveCoverForGraph$CoverClassNiceNames)
Habitat.freq.df.aveCoverForGraph$CoverClassNiceNames[Habitat.freq.df.aveCoverForGraph$CoverClassNiceNames=="Grassland"]="Treeless"
Habitat.freq.df.aveCoverForGraph$CoverClassNiceNames=as.factor(Habitat.freq.df.aveCoverForGraph$CoverClassNiceNames)
Habitat.freq.df.aveCoverForGraph$CoverClassNiceNames=relevel(Habitat.freq.df.aveCoverForGraph$CoverClassNiceNames,"Treeless")
Habitat.freq.df.aveCoverForGraph$CoverClassNiceNames=relevel(Habitat.freq.df.aveCoverForGraph$CoverClassNiceNames,"Deciduous")
Habitat.freq.df.aveCoverForGraph$CoverClassNiceNames=relevel(Habitat.freq.df.aveCoverForGraph$CoverClassNiceNames,"Mixedwood")
Habitat.freq.df.aveCoverForGraph$CoverClassNiceNames=relevel(Habitat.freq.df.aveCoverForGraph$CoverClassNiceNames,"Conifer")
Habitat.freq.df.aveCoverForGraph$HarvestTreatmentNiceNames=as.character(Habitat.freq.df.aveCoverForGraph$HarvestTreatmentNiceNames)
Habitat.freq.df.aveCoverForGraph$HarvestTreatmentNiceNames[Habitat.freq.df.aveCoverForGraph$HarvestTreatmentNiceNames=="Drought + 0.3% CC.yr-1"]="Baseline Harvesting"
Habitat.freq.df.aveCoverForGraph$HarvestTreatmentNiceNames[Habitat.freq.df.aveCoverForGraph$HarvestTreatmentNiceNames=="Drought + 0.6% CC.yr-1"]="High Harvesting"
Habitat.freq.df.aveCoverForGraph$HarvestTreatmentNiceNames[Habitat.freq.df.aveCoverForGraph$HarvestTreatmentNiceNames=="Only drought"]="No Harvesting"
Habitat.freq.df.aveCoverForGraph$HarvestTreatmentNiceNames=as.factor(Habitat.freq.df.aveCoverForGraph$HarvestTreatmentNiceNames)
Habitat.freq.df.aveCoverForGraph$HarvestTreatmentNiceNames=relevel(Habitat.freq.df.aveCoverForGraph$HarvestTreatmentNiceNames,"High Harvesting")
Habitat.freq.df.aveCoverForGraph$HarvestTreatmentNiceNames=relevel(Habitat.freq.df.aveCoverForGraph$HarvestTreatmentNiceNames,"Baseline Harvesting")
Habitat.freq.df.aveCoverForGraph$HarvestTreatmentNiceNames=relevel(Habitat.freq.df.aveCoverForGraph$HarvestTreatmentNiceNames,"No Harvesting")

### Retire le RCP2.6
Habitat.freq.df.aveCoverForGraph=Habitat.freq.df.aveCoverForGraph[Habitat.freq.df.aveCoverForGraph$scenario!="RCP26",]

g3 <- ggplot(Habitat.freq.df.aveCoverForGraph, aes(x=Year, y=pctHabitat.mean.sum, fill=CoverClassNiceNames, colour = CoverClassNiceNames))
g3 <- g3 +
  stat_summary(fun.y="sum", geom="area", col=NA, position = position_stack(reverse = TRUE)) +
  labs(title = paste0("Evolution of habitat classes\n", "ALPAC", "\n"),
       subtitle = "Cumulative percentage")

g3 <- g3 +
  facet_grid(scenario ~ HarvestTreatmentNiceNames) +
  scale_fill_manual("Habitat Classes", values=Habitat.Class$ColorCover[!duplicated(Habitat.Class$ColorCover)]) +
  guides(fill = guide_legend(reverse = T),
         colour = guide_legend(reverse = T)) +
  labs(#title = paste0("Evolution of landscape composition\n ", ecoName, " - ",s, "\n", ClassesNamesToGraph, "\n"),
    y = "Mean percentage\n")+
  theme(axis.text.x=element_text(angle=45, vjust=0.5))

png(filename=paste0(wwd, "Cover.stack.png"),
    width = 3200, height = 2400, pointsize=72)
print(g3 + theme_grey(base_size=72) +
        scale_x_continuous(breaks = breaks) +
        theme(axis.title.x = element_blank(),
              axis.text.x = element_text(size=44, angle = 45, hjust = 1),
              axis.text.y = element_text(size=48),
              strip.text.x = element_text(size=60),
              strip.text.y = element_text(size=60)))
dev.off()
g3
# ggsave(file="Depot_DD/Fig4.png", plot = g3,width = 6, height = 4, units = "in",dpi=600)








###################################### Figure 3

AgeClass <- as.data.frame(rbind(
  c("Young", "tomato4"),
  c("Closed","yellow" ),
  c("Mature","green1"),
  c("Old","green4")
))

names(AgeClass) <- c("AgeClassSimple", "ColorAgeClass")
AgeClass$AgeClassSimple<- as.character(AgeClass$AgeClassSimple)
AgeClass$ColorAgeClass<- as.character(AgeClass$ColorAgeClass)

table(Habitat.freq.df.ave2ForGraph$AgeClass)
head(Habitat.freq.df.ave2ForGraph)

Habitat.freq.df.ave2ForGraph$AgeClassSimple=as.numeric(as.character(Habitat.freq.df.ave2ForGraph$AgeClass))
Habitat.freq.df.ave2ForGraph$AgeClassSimple=as.character(Habitat.freq.df.ave2ForGraph$AgeClassSimple)
Habitat.freq.df.ave2ForGraph$AgeClassSimple[Habitat.freq.df.ave2ForGraph$AgeClassSimple%in%c(0,10,20)]="Young"
Habitat.freq.df.ave2ForGraph$AgeClassSimple[Habitat.freq.df.ave2ForGraph$AgeClassSimple%in%c(40)]="Closed"
Habitat.freq.df.ave2ForGraph$AgeClassSimple[Habitat.freq.df.ave2ForGraph$AgeClassSimple%in%c(60)]="Mature"
Habitat.freq.df.ave2ForGraph$AgeClassSimple[Habitat.freq.df.ave2ForGraph$AgeClassSimple%in%c(80,100,120,140)]="Old"
Habitat.freq.df.ave2ForGraph$AgeClassSimple=as.factor(Habitat.freq.df.ave2ForGraph$AgeClassSimple)
Habitat.freq.df.ave2ForGraph$AgeClassSimple=relevel(Habitat.freq.df.ave2ForGraph$AgeClassSimple, "Old")
Habitat.freq.df.ave2ForGraph$AgeClassSimple=relevel(Habitat.freq.df.ave2ForGraph$AgeClassSimple, "Mature")
Habitat.freq.df.ave2ForGraph$AgeClassSimple=relevel(Habitat.freq.df.ave2ForGraph$AgeClassSimple, "Closed")
Habitat.freq.df.ave2ForGraph$AgeClassSimple=relevel(Habitat.freq.df.ave2ForGraph$AgeClassSimple, "Young")
Habitat.freq.df.ave2ForGraph$HarvestTreatmentNiceNames2=as.character(Habitat.freq.df.ave2ForGraph$HarvestTreatmentNiceNames)
Habitat.freq.df.ave2ForGraph$HarvestTreatmentNiceNames2[Habitat.freq.df.ave2ForGraph$HarvestTreatmentNiceNames2%in%c("Only drought")]="No Harvesting"
Habitat.freq.df.ave2ForGraph$HarvestTreatmentNiceNames2[Habitat.freq.df.ave2ForGraph$HarvestTreatmentNiceNames2%in%c("Drought + 0.3% CC.yr-1")]="Baseline Harvesting"
Habitat.freq.df.ave2ForGraph$HarvestTreatmentNiceNames2[Habitat.freq.df.ave2ForGraph$HarvestTreatmentNiceNames2%in%c("Drought + 0.6% CC.yr-1")]="High Harvesting"
table(Habitat.freq.df.ave2ForGraph$HarvestTreatmentNiceNames2)
Habitat.freq.df.ave2ForGraph$HarvestTreatmentNiceNames2=as.factor(Habitat.freq.df.ave2ForGraph$HarvestTreatmentNiceNames2)
Habitat.freq.df.ave2ForGraph$HarvestTreatmentNiceNames2=relevel(Habitat.freq.df.ave2ForGraph$HarvestTreatmentNiceNames2, "High Harvesting")
Habitat.freq.df.ave2ForGraph$HarvestTreatmentNiceNames2=relevel(Habitat.freq.df.ave2ForGraph$HarvestTreatmentNiceNames2, "Baseline Harvesting")
Habitat.freq.df.ave2ForGraph$HarvestTreatmentNiceNames2=relevel(Habitat.freq.df.ave2ForGraph$HarvestTreatmentNiceNames2, "No Harvesting")
Habitat.freq.df.ave2ForGraph=Habitat.freq.df.ave2ForGraph[Habitat.freq.df.ave2ForGraph$scenario!="RCP26",]


  DataToGraph <- subset(Habitat.freq.df.ave2ForGraph)
  g3 <- ggplot(DataToGraph, aes(x=Year, y=pctHabitat.mean, fill=AgeClassSimple, colour = AgeClassSimple))
  g3 <- g3 +
    stat_summary(fun.y="sum", geom="area", col=NA, position = position_stack(reverse = TRUE)) +
    labs(title = paste0("Evolution of age classes\n", "ALPAC\n", "\n"),
         subtitle = "Cumulative percentage")
  
  g3 <- g3 +
    facet_grid(scenario ~ HarvestTreatmentNiceNames2) +
    scale_fill_manual("Age Classes", values=AgeClass$ColorAgeClass) +
    guides(fill = guide_legend(reverse = T),
           colour = guide_legend(reverse = T)) +
    labs(#title = paste0("Evolution of landscape composition\n ", ecoName, " - ",s, "\n", ClassesNamesToGraph, "\n"),
      y = "Mean percentage\n")+
    theme(axis.text.x=element_text(angle=45, vjust=0.5))
  
  png(filename=paste0(wwd, "AgeClassByHabitat_",  "_stack.png"),
      width = 3200, height = 2400, pointsize=72)
  print(g3 + theme_grey(base_size=72) +
          scale_x_continuous(breaks = breaks) +
          theme(axis.title.x = element_blank(),
                axis.text.x = element_text(size=44, angle = 45, hjust = 1),
                axis.text.y = element_text(size=48),
                strip.text.x = element_text(size=60),
                strip.text.y = element_text(size=60)))
  dev.off()
  g3
